/// <reference types="react" />
export type Callback = (start: number, end: number) => void;
export type Strategy = (text: any, callback: Callback) => void;
export type Range = [start: number, end: number];
export type Component = Element | JSX.Element | ((props: any) => Element) | ((props: any) => JSX.Element);
export type CustomObject = {
    highlight: Highlight;
    component?: Component;
    className?: string;
};
export type Highlight = string | RegExp | Strategy | CustomObject | Range | Highlight[];
export type StrategyAndComponent = {
    strategy: Strategy;
    component: Component;
};
export declare const highlightToStrategyAndComponents: (highlight: Highlight, classHint?: string, componentHint?: Component) => StrategyAndComponent[];
